Index: /java/main/src/main/java/com/framsticks/communication/ClientConnection.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/ClientConnection.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/communication/ClientConnection.java	(revision 96)
@@ -11,11 +11,13 @@
 import com.framsticks.util.dispatching.Dispatcher;
 import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.JoinableState;
 import com.framsticks.util.lang.Pair;
 import com.framsticks.util.lang.Strings;
+
+import org.apache.log4j.Level;
 import org.apache.log4j.Logger;
 
 import java.io.IOException;
 import java.net.Socket;
-import java.net.SocketException;
 import java.util.*;
 import java.util.regex.Matcher;
@@ -39,31 +41,18 @@
 	}
 
+	public ClientConnection(String address) {
+		super(address, "client connection");
+		Matcher matcher = addressPattern.matcher(address);
+		if (!matcher.matches()) {
+			log.fatal("invalid address: " + address);
+			hostName = null;
+			port = 0;
+			return;
+		}
+		hostName = matcher.group(1);
+		port = matcher.group(3) != null ? Integer.parseInt(matcher.group(3)) : 9009;
+	}
 
 	protected StateFunctor connectedFunctor;
-
-	@Override
-	protected void joinableStart() {
-		try {
-			log.debug("connecting to " + address);
-
-			socket = new Socket(hostName, port);
-
-			socket.setSoTimeout(500);
-
-			log.debug("connected to " + hostName + ":" + port);
-			connected = true;
-			runThreads();
-
-			connectedFunctor.call(null);
-		} catch (SocketException e) {
-			log.error("failed to connect: " + e);
-			connectedFunctor.call(e);
-		} catch (IOException e) {
-			log.error("buffer creation failure");
-			connectedFunctor.call(e);
-			// close();
-		}
-	}
-
 
 	private static abstract class InboundMessage {
@@ -78,4 +67,5 @@
 			currentFilePath = path;
 		}
+
 		protected void finishCurrentFile() {
 			if (currentFileContent == null) {
@@ -84,13 +74,13 @@
 			files.add(new File(currentFilePath, new ListSource(currentFileContent)));
 			currentFilePath = null;
-			currentFileContent= null;
+			currentFileContent = null;
 		}
 
 		public abstract void startFile(String path);
 
-		public void addLine(String line) {
+		public final void addLine(String line) {
 			assert line != null;
 			assert currentFileContent != null;
-			currentFileContent.add(line.substring(0, line.length() - 1));
+			currentFileContent.add(line);
 		}
 
@@ -127,12 +117,14 @@
 		public void startFile(String path) {
 			finishCurrentFile();
-			if (path == null) {
+			if (!Strings.notEmpty(path)) {
 				assert request instanceof ApplicationRequest;
-				path = ((ApplicationRequest)request).getPath();
-			}
+				path = ((ApplicationRequest) request).getPath();
+			}
+			Strings.assureNotEmpty(path);
 			initCurrentFile(path);
 		}
 
 		public void eof() {
+			assert Strings.notEmpty(currentFilePath);
 			finishCurrentFile();
 			//no-operation
@@ -153,6 +145,6 @@
 		}
 	}
+
 	private Map<Integer, SentQuery<?>> queryMap = new HashMap<>();
-
 
 	protected final String hostName;
@@ -161,19 +153,6 @@
 	private static Pattern addressPattern = Pattern.compile("^([^:]*)(:([0-9]+))?$");
 
-	public ClientConnection(String address) {
-		super(address);
-		Matcher matcher = addressPattern.matcher(address);
-		if (!matcher.matches()) {
-			log.fatal("invalid address: " + address);
-			hostName = null;
-			port = 0;
-			return;
-		}
-		hostName = matcher.group(1);
-		port = matcher.group(3) != null ? Integer.parseInt(matcher.group(3)) : 9009;
-	}
 
 	private SentQuery<?> currentlySentQuery;
-
 
 	public <C extends Connection> void send(Request request, ResponseCallback<C> callback) {
@@ -184,8 +163,9 @@
 	public <C> void send(Request request, Dispatcher<C> dispatcher, ResponseCallback<? extends C> callback) {
 
-		if (!isConnected()) {
+		if (getState().ordinal() > JoinableState.RUNNING.ordinal()) {
 			log.fatal("not connected");
 			return;
 		}
+
 		final SentQuery<C> sentQuery = new SentQuery<C>();
 		sentQuery.request = request;
@@ -193,5 +173,5 @@
 		sentQuery.dispatcher = dispatcher;
 
-		senderThread.dispatch(new RunAt<Connection>(){
+		senderThread.dispatch(new RunAt<Connection>() {
 			@Override
 			public void run() {
@@ -220,8 +200,10 @@
 					message.append(" ").append(id);
 				}
+				message.append(" ");
 				sentQuery.request.construct(message);
 				String out = message.toString();
 
 				output.println(out);
+				output.flush();
 				log.debug("sending query: " + out);
 
@@ -234,7 +216,6 @@
 			notifyAll();
 		}
-		*/
-	}
-
+		 */
+	}
 
 	@Override
@@ -272,33 +253,25 @@
 	}
 
-	public void sendQueryVersion(final int version, final StateFunctor stateFunctor) {
-		send(new VersionRequest().version(version), new StateCallback<Connection>() {
+	public void sendQueryVersion(final int version, StateFunctor stateFunctor) {
+		send(new VersionRequest().version(version), new StateCallback<Connection>(stateFunctor) {
 			@Override
-			public void call(Exception e) {
-				if (e != null) {
-					log.fatal("failed to upgrade protocol to version: " + version);
-					return;
-				}
+			public void callImpl() {
 				protocolVersion = version;
 				if (version < 4) {
 					/** it is an implicit loop here*/
-					sendQueryVersion(version + 1, stateFunctor);
+					sendQueryVersion(version + 1, move());
 					return;
 				}
-				send(new UseRequest().feature("request_id"), new StateCallback<Connection>() {
+				send(new UseRequest().feature("request_id"), new StateCallback<Connection>(move()) {
 					@Override
-					public void call(Exception e) {
-						requestIdEnabled = e == null;
-						/*
-						synchronized (ClientConnection.this) {
-							ClientConnection.this.notifyAll();
-						}
-						*/
-						if (!requestIdEnabled) {
-							log.fatal("protocol negotiation failed");
-							stateFunctor.call(new Exception("protocol negotiation failed", e));
-							return;
-						}
-						stateFunctor.call(null);
+					public void handle(FramsticksException exception) {
+						requestIdEnabled = false;
+						log.fatal("protocol negotiation failed");
+						super.handle(new FramsticksException().msg("protocol negotiation failed").cause(exception));
+					}
+
+					@Override
+					public void callImpl() {
+						requestIdEnabled = true;
 					}
 				});
@@ -307,5 +280,4 @@
 		});
 	}
-
 
 	private synchronized SentQuery<?> fetchQuery(Integer id, boolean remove) {
@@ -348,5 +320,5 @@
 
 	protected void processEvent(String rest) {
-		Matcher matcher = eventPattern.matcher(rest);
+		Matcher matcher = Request.EVENT_PATTERN.matcher(rest);
 		if (!matcher.matches()) {
 			log.error("invalid event line: " + rest);
@@ -363,40 +335,64 @@
 	}
 
-
 	protected void processMessageStartingWith(String line) {
-		Pair<String, String> command = Strings.splitIntoPair(line, ' ', "\n");
-		if (command.first.equals("event")) {
-			processEvent(command.second);
-			return;
-		}
-		Pair<Integer, String> rest = parseRest(command.second);
-
-		if (command.first.equals("file")) {
-			SentQuery<?> sentQuery = fetchQuery(rest.first, false);
-			sentQuery.startFile(rest.second);
-			processMessage(sentQuery);
-			return;
-		}
-
-		SentQuery<?> sentQuery = fetchQuery(rest.first, true);
-		if (sentQuery == null) {
-			return;
-		}
-		log.debug("parsing response for request " + sentQuery);
-
-		sentQuery.dispatchResponseProcess(new Response(command.first.equals("ok"), rest.second, sentQuery.getFiles()));
+		try {
+			Pair<CharSequence, CharSequence> command = Request.takeIdentifier(line);
+			if (command.first.equals("event")) {
+				processEvent(command.second.toString());
+				return;
+			}
+			Pair<Integer, CharSequence> rest = takeRequestId(command.second);
+
+			if (command.first.equals("file")) {
+				SentQuery<?> sentQuery = fetchQuery(rest.first, false);
+				sentQuery.startFile(rest.second.toString());
+				processMessage(sentQuery);
+				return;
+			}
+
+			SentQuery<?> sentQuery = fetchQuery(rest.first, true);
+			if (sentQuery == null) {
+				return;
+			}
+			log.debug("parsing response for request " + sentQuery);
+
+			sentQuery.dispatchResponseProcess(new Response(command.first.equals("ok"), rest.second.toString(), sentQuery.getFiles()));
+		} catch (FramsticksException e) {
+			throw new FramsticksException().msg("failed to process message").arg("starting with line", line).cause(e);
+		}
 	}
 
 	@Override
 	protected void receiverThreadRoutine() {
-		while (connected) {
+		while (isRunning() && !isConnected()) {
+			log.debug("connecting to " + address);
+			try {
+				socket = new Socket(hostName, port);
+			} catch (IOException e) {
+				log.info(this + " failed to connect (retrying): " + e);
+				Dispatching.sleep(0.5);
+			}
+		}
+
+		log.debug(this + " connected");
+		try {
+			socket.setSoTimeout(500);
+			setupStreams();
+		} catch (Exception e) {
+			throw new FramsticksException().msg("failed to initialize socket").cause(e).arg("connection", this);
+		}
+
+		connectedFunctor.call();
+
+		while (isRunning() && isConnected()) {
 			try {
 				processMessageStartingWith(getLine());
 			} catch (Exception e) {
+				log.log(isRunning() ? Level.ERROR : Level.DEBUG, "caught exception: ", e);
 				break;
 			}
 		}
-	}
-
-
+		interrupt();
+		finish();
+	}
 }
Index: /java/main/src/main/java/com/framsticks/communication/Connection.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/Connection.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/communication/Connection.java	(revision 96)
@@ -12,6 +12,4 @@
 import java.net.Socket;
 import java.net.SocketTimeoutException;
-import java.util.regex.Matcher;
-import java.util.regex.Pattern;
 
 import com.framsticks.util.dispatching.AbstractJoinable;
@@ -33,6 +31,4 @@
 	protected Socket socket = null;
 
-	protected volatile boolean connected = false;
-
 	public boolean requestIdEnabled = false;
 
@@ -43,35 +39,48 @@
 	}
 	protected final String address;
+	protected final String description;
 
 	protected final Thread<Connection> senderThread = new Thread<>();
 	protected final Thread<Connection> receiverThread = new Thread<>();
-	protected final JoinableCollection<Thread<Connection>> threads = new JoinableCollection<>(true);
+	protected final JoinableCollection<Thread<Connection>> threads = new JoinableCollection<>();
+
+	protected void setUpThreadNames(String name) {
+	}
 
 	/**
 	 *
 	 */
-	public Connection(String address) {
+	public Connection(String address, String description) {
 		this.address = address;
+		this.description = description;
+		threads.setObservableName(address + " connection threads");
 		threads.add(senderThread);
 		threads.add(receiverThread);
-	}
-	public boolean isConnected() {
-		return connected;
-	}
-
-
-	protected static final String ARGUMENT_PATTERN_FRAGMENT = "((?:\\S+)|(?:\"[^\"]*\"))";
-	protected static final Pattern requestIdEnabledPattern = Pattern.compile("^\\s*([0-9]+)(?:\\s+" + ARGUMENT_PATTERN_FRAGMENT + ")?\\n$");
-	protected static final Pattern requestIDisabledPattern = Pattern.compile("^\\s*" + ARGUMENT_PATTERN_FRAGMENT + "?\\n$");
-	protected static final Pattern eventPattern = Pattern.compile("^\\s*(\\S+)\\s*(\\S+)\\n");
-
-
-	protected final Pair<Integer, String> parseRest(String rest) {
-		Matcher matcher = (requestIdEnabled ? requestIdEnabledPattern : requestIDisabledPattern).matcher(rest);
-		if (!matcher.matches()) {
-			log.fatal("unmatched first line of input: " + rest);
-			return null;
-		}
-		return new Pair<Integer, String>(requestIdEnabled ? Integer.parseInt(matcher.group(1)) : null, matcher.group(requestIdEnabled ? 2 : 1));
+
+		senderThread.setName(description + " thread " + address + " sender");
+		receiverThread.setName(description + " thread " + address + " receiver");
+	}
+
+	public synchronized boolean isConnected() {
+		return socket != null && socket.isConnected();
+	}
+
+
+	// protected static final String ARGUMENT_PATTERN_FRAGMENT = "((?:\\S+)|(?:\\\"[^\"]*\\\"))";
+	// protected static final Pattern REQUEST_ID_ENABLED_PATTERN = Pattern.compile("^\\s*([0-9]+)(?:\\s+" + ARGUMENT_PATTERN_FRAGMENT + ")?$");
+	// protected static final Pattern REQUEST_ID_DISABLED_PATTERN = Pattern.compile("^\\s*" + ARGUMENT_PATTERN_FRAGMENT + "?$");
+
+	// // protected final Pair<String, String> breakLine(String line)
+	// protected final Pair<Integer, String> parseRest(String rest) {
+	// 	Matcher matcher = (requestIdEnabled ? REQUEST_ID_ENABLED_PATTERN : REQUEST_ID_DISABLED_PATTERN).matcher(rest);
+	// 	if (!matcher.matches()) {
+	// 		log.fatal("unmatched first line of input: '" + rest + "'");
+	// 		return null;
+	// 	}
+	// 	return new Pair<Integer, String>(requestIdEnabled ? Integer.parseInt(matcher.group(1)) : null, matcher.group(requestIdEnabled ? 2 : 1));
+	// }
+
+	protected final Pair<Integer, CharSequence> takeRequestId(CharSequence line) {
+		return Request.takeRequestId(requestIdEnabled, line);
 	}
 
@@ -81,8 +90,8 @@
 	int iterator = 0;
 	int bufferStart = 0;
-	char[] readBuffer = new char[BUFFER_LENGTH];
+	final char[] readBuffer = new char[BUFFER_LENGTH];
 
 	protected String getLine() {
-		StringBuilder lineBuffer = new StringBuilder();
+		final StringBuilder lineBuffer = new StringBuilder();
 		try {
 			while (!Thread.interrupted()) {
@@ -92,10 +101,16 @@
 						continue;
 					}
-					lineBuffer.append(readBuffer, bufferStart, iterator - bufferStart + 1);
+					/** Do not append new line. */
+					lineBuffer.append(readBuffer, bufferStart, iterator - bufferStart);
 					++iterator;
 					bufferStart = iterator;
 					return lineBuffer.toString();
 				}
-				lineBuffer.append(readBuffer, bufferStart, readChars - bufferStart);
+				final int length = readChars - bufferStart;
+				if (length > 0) {
+					assert bufferStart >= 0 && bufferStart < BUFFER_LENGTH;
+					assert bufferStart + length <= BUFFER_LENGTH;
+					lineBuffer.append(readBuffer, bufferStart, length);
+				}
 
 				readChars = 0;
@@ -118,28 +133,15 @@
 	protected abstract void receiverThreadRoutine();
 
-	protected void setUpThread(Thread<Connection> thread, String name) {
-		thread.setName("connection thread " + address + " " + name);
-	}
-
-	protected void runThreads() {
+
+	protected void setupStreams() {
 		try {
 			output = new PrintWriter(new OutputStreamWriter(socket.getOutputStream(), Encoding.getFramsticksCharset()), true);
 			input = new BufferedReader(new InputStreamReader(socket.getInputStream(), Encoding.getFramsticksCharset()));
+			synchronized (this) {
+				this.notifyAll();
+			}
 		} catch (IOException e) {
-			log.error("buffer creation failure");
-			return;
+			throw new FramsticksException().msg("failed to setup streams").cause(e).arg("connection", this);
 		}
-
-		setUpThread(senderThread, "sender");
-		setUpThread(receiverThread, "receiver");
-		Dispatching.use(threads, this);
-
-		receiverThread.dispatch(new RunAt<Connection>() {
-			@Override
-			public void run() {
-				receiverThreadRoutine();
-			}
-		});
-
 	}
 
@@ -153,13 +155,4 @@
 	}
 
-	@Override
-	protected void joinableInterrupt() {
-		protocolVersion = -1;
-
-		connected = false;
-		Dispatching.drop(threads, this);
-
-		// finish();
-	}
 
 	@Override
@@ -193,7 +186,42 @@
 
 	@Override
+	public String getName() {
+		return description + " " + address;
+	}
+
+	@Override
+	protected void joinableStart() {
+		Dispatching.use(threads, this);
+
+		senderThread.dispatch(new RunAt<Connection>() {
+			@Override
+			public void run() {
+				synchronized (Connection.this) {
+					while (state.equals(JoinableState.RUNNING) && output == null) {
+						Dispatching.wait(Connection.this, 500);
+					}
+				}
+			}
+		});
+
+		receiverThread.dispatch(new RunAt<Connection>() {
+			@Override
+			public void run() {
+				receiverThreadRoutine();
+			}
+		});
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		protocolVersion = -1;
+		Dispatching.drop(threads, this);
+		finish();
+	}
+
+
+	@Override
 	protected void joinableJoin() throws InterruptedException {
 		Dispatching.join(threads);
-
 	}
 
Index: /java/main/src/main/java/com/framsticks/communication/File.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/File.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/communication/File.java	(revision 96)
@@ -1,5 +1,11 @@
 package com.framsticks.communication;
 
+import java.util.ArrayList;
+import java.util.List;
+
+import javax.annotation.Nonnull;
+
 import com.framsticks.params.SourceInterface;
+// import com.framsticks.util.lang.Strings;
 
 /**
@@ -7,18 +13,25 @@
  */
 public final class File {
-    protected final String path;
-    protected final SourceInterface content;
+	protected final String path;
+	protected final SourceInterface content;
 
-    public File(String path, SourceInterface content) {
-        this.path = path;
-        this.content = content;
-    }
+	public File(@Nonnull String path, @Nonnull SourceInterface content) {
+		// assert Strings.notEmpty(path);
+		this.path = path;
+		this.content = content;
+	}
 
-    public String getPath() {
-        return path;
-    }
+	public String getPath() {
+		return path;
+	}
 
-    public SourceInterface getContent() {
-        return content;
-    }
+	public SourceInterface getContent() {
+		return content;
+	}
+
+	public static List<File> single(File file) {
+		List<File> result = new ArrayList<File>();
+		result.add(file);
+		return result;
+	}
 }
Index: /java/main/src/main/java/com/framsticks/communication/Request.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/Request.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/communication/Request.java	(revision 96)
@@ -1,5 +1,10 @@
 package com.framsticks.communication;
 
+import java.util.regex.Matcher;
+import java.util.regex.Pattern;
+
 import com.framsticks.communication.queries.*;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.lang.Pair;
 
 /**
@@ -8,4 +13,11 @@
 public abstract class Request {
 
+	public abstract String getCommand();
+
+	protected abstract StringBuilder construct(StringBuilder buffer);
+
+
+
+
 	public static void quoteValue(StringBuilder builder, String value) {
 		String quote = ((value.indexOf(' ') > 0) || (value.length() == 0) ? "\"" : "");
@@ -13,39 +25,92 @@
 	}
 
-	public abstract String getCommand();
-
-	protected abstract StringBuilder construct(StringBuilder buffer);
-	//private static Pattern queryPattern = Pattern.compile("^(\\S+)\\s+(\\S+)(?:\\s+(\\S+))?$");
+	public static Request parse(CharSequence type, CharSequence rest) {
+		final Request request = Request.createRequestByTypeString(type.toString());
+		request.parseRest(rest);
+		return request;
+	}
 
 	public static Request createRequestByTypeString(String type) {
-		if (type.equals("get")) {
-			return new GetRequest();
+		switch (type) {
+			case "get": return new GetRequest();
+			case "set": return new SetRequest();
+			case "info": return new InfoRequest();
+			case "call": return new CallRequest();
+			case "reg": return new RegistrationRequest();
+			case "use": return new UseRequest();
+			case "version": return new VersionRequest();
 		}
-		if (type.equals("set")) {
-			return new SetRequest();
-		}
-		if (type.equals("info")) {
-			return new InfoRequest();
-		}
-		if (type.equals("call")) {
-			return new CallRequest();
-		}
-		if (type.equals("reg")) {
-			return new RegistrationRequest();
-		}
-		if (type.equals("use")) {
-			return new UseRequest();
-		}
-		if (type.equals("version")) {
-			return new VersionRequest();
-		}
-		return null;
+		throw new FramsticksException().msg("unknown request type").arg("type", type);
 	}
 
-	public abstract void parseRest(String rest);
+	public abstract CharSequence parseRest(CharSequence rest);
 
 	@Override
 	public String toString() {
-		return construct(new StringBuilder().append(getCommand())).toString();
+		return getCommand() + " request";
 	}
+
+	public String stringRepresentation() {
+		return construct(new StringBuilder().append(getCommand()).append(" ")).toString();
+	}
+
+	public static final Pattern EVENT_PATTERN = Pattern.compile("^\\s*(\\S+)\\s*(\\S+)");
+
+	public static final Pattern STRING_BREAKER_PATTERN = Pattern.compile("^\\s*(?:(?:\\\"([^\"]*)\\\")|([^ ]+))\\s*(.*)$");
+	public static final Pattern IDENTIFIER_BREAKER_PATTERN = Pattern.compile("^\\s*([^ ]+)\\s*(.*)$");
+
+	// public static Matcher match(Pattern pattern, CharSequence line) {
+	// 	Matcher matcher = pattern.matcher(line);
+	// 	if (!matcher.matches()) {
+	// 		return null;
+	// 		// throw new FramsticksException().msg("failed to take").arg("pattern", pattern).arg("line", line);
+	// 	}
+	// 	return matcher;
+	// }
+
+	public static Pair<CharSequence, CharSequence> takeIdentifier(CharSequence line) {
+		Matcher matcher = IDENTIFIER_BREAKER_PATTERN.matcher(line);
+		if (!matcher.matches()) {
+			return null;
+		}
+		return new Pair<CharSequence, CharSequence>(line.subSequence(matcher.start(1), matcher.end(1)), line.subSequence(matcher.start(2), matcher.end(2)));
+	}
+
+	public static CharSequence takeGroup(CharSequence input, Matcher matcher, int group) {
+		// return (matcher.start(group) == matcher.end(group)) ? null : input.subSequence(matcher.start(group), matcher.end(group));
+		return input.subSequence(matcher.start(group), matcher.end(group));
+	}
+
+	public static Pair<CharSequence, CharSequence> takeString(CharSequence line) {
+		Matcher matcher = STRING_BREAKER_PATTERN.matcher(line);
+		if (!matcher.matches()) {
+			return null;
+		}
+		assert ((matcher.start(1) == -1) != (matcher.start(2) == -1));
+		return new Pair<CharSequence, CharSequence>(takeGroup(line, matcher, (matcher.start(1) != -1 ? 1 : 2)), takeGroup(line, matcher, 3));
+	}
+
+	protected static final Pattern REQUEST_ID_BREAKER_PATTERN = Pattern.compile("^\\s*([0-9]+)\\s*(.*)$");
+
+	protected final static Pair<Integer, CharSequence> takeRequestId(boolean withId, CharSequence line) {
+		if (withId) {
+			Matcher matcher = REQUEST_ID_BREAKER_PATTERN.matcher(line);
+			if (!matcher.matches()) {
+				return null;
+			}
+			return new Pair<Integer, CharSequence>(Integer.valueOf(takeGroup(line, matcher, 1).toString()), takeGroup(line, matcher, 2));
+		}
+		return new Pair<Integer, CharSequence>(null, line);
+	}
+
+	public static StringBuilder quoteArgumentIfNeeded(StringBuilder builder, Object argument) {
+		String r = argument.toString();
+		if (r.indexOf(' ') != -1) {
+			builder.append('"').append(r).append('"');
+		} else {
+			builder.append(r);
+		}
+		return builder;
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/communication/ResponseCallback.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/ResponseCallback.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/communication/ResponseCallback.java	(revision 96)
@@ -1,8 +1,17 @@
 package com.framsticks.communication;
+
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
 
 /**
  * @author Piotr Sniegowski
  */
-public interface ResponseCallback<C> {
-	public void process(Response response);
+public abstract class ResponseCallback<C> implements ExceptionResultHandler {
+	public abstract void process(Response response);
+
+	@Override
+	public void handle(FramsticksException e) {
+		process(new Response(false, e.getMsg(), null));
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/communication/ServerConnection.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/ServerConnection.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/communication/ServerConnection.java	(revision 96)
@@ -3,6 +3,10 @@
 import com.framsticks.communication.queries.*;
 import com.framsticks.params.SourceInterface;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.lang.Holder;
 import com.framsticks.util.lang.Pair;
 import com.framsticks.util.lang.Strings;
+
+import org.apache.log4j.Level;
 import org.apache.log4j.Logger;
 
@@ -20,21 +24,24 @@
 
 	public ServerConnection(Socket socket, RequestHandler requestHandler) {
-		super("todo");
+		super(socket.getInetAddress().getHostAddress(), "server connection");
 		this.socket = socket;
 		this.requestHandler = requestHandler;
-		connected = true;
-
+		// socket.setSoTimeout(500);
+		setupStreams();
 	}
 
-	@Override
-	public String toString() {
-		return socket.getInetAddress().getHostAddress();
-	}
 
 	@Override
 	protected void receiverThreadRoutine() {
-		while (connected) {
-			processNextRequest();
+		while (isRunning() && isConnected()) {
+			try {
+				processNextRequest();
+			} catch (Exception e) {
+				log.log((isRunning() ? Level.ERROR : Level.DEBUG), "caught exception: ", e);
+				break;
+			}
 		}
+		interrupt();
+		finish();
 	}
 
@@ -85,6 +92,7 @@
 				output.print(outId);
 				if (Strings.notEmpty(response.getComment())) {
-					output.print(' ');
+					output.print(" \"");
 					output.print(response.getComment());
+					output.print('"');
 				}
 				output.print('\n');
@@ -96,34 +104,30 @@
 
 	protected void processNextRequest() {
-		String line = getLine();
-		Pair<String, String> command = Strings.splitIntoPair(line, ' ', "\n");
-		final Pair<Integer, String> rest = parseRest(command.second);
-		if (rest == null) {
-			respond(new Response(false, "\"invalid input\"", null), null);
+		final Holder<Integer> id = new Holder<>();
+		final String line = getLine();
+		try {
+			Pair<CharSequence, CharSequence> command = Request.takeIdentifier(line);
+			final Pair<Integer, CharSequence> rest = takeRequestId(command.second);
+			id.set(rest.first);
+
+			final Request request = Request.parse(command.first, rest.second);
+
+			if (log.isTraceEnabled()) {
+				log.trace("read request: " + request);
+			}
+
+			handleRequest(request, new ResponseCallback<ServerConnection>() {
+				@Override
+				public void process(Response response) {
+					respond(response, rest.first);
+				}
+			});
+		} catch (FramsticksException e) {
+			e.arg("id", id.get()).arg("line", line);
+			log.error("error: ", e);
+			respond(new Response(false, "invalid input: " + e.getMsg(), null), id.get());
 			return;
 		}
 
-		final Request request = Request.createRequestByTypeString(command.first);
-		if (request == null) {
-			respond(new Response(false, "\"invalid input\"", null), null);
-			return;
-		}
-		request.parseRest(rest.second);
-		if (log.isTraceEnabled()) {
-			log.trace("read request: " + request);
-		}
-
-		handleRequest(request, new ResponseCallback<ServerConnection>() {
-			@Override
-			public void process(Response response) {
-				respond(response, rest.first);
-			}
-		});
-	}
-
-	@Override
-	protected void joinableStart() {
-		// TODO Auto-generated method stub
-
 	}
 }
Index: /java/main/src/main/java/com/framsticks/communication/StateCallback.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/StateCallback.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/communication/StateCallback.java	(revision 96)
@@ -1,4 +1,5 @@
 package com.framsticks.communication;
 
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.StateFunctor;
 
@@ -6,8 +7,55 @@
  * @author Piotr Sniegowski
  */
-public abstract class StateCallback<C> implements ResponseCallback<C>, StateFunctor {
+public abstract class StateCallback<C> extends ResponseCallback<C> implements StateFunctor {
+
+
+	protected StateFunctor wrapped;
+
+	public StateCallback(StateFunctor wrapped) {
+		this.wrapped = wrapped;
+	}
+
+	public StateCallback() {
+		this.wrapped = null;
+	}
+
+	protected StateFunctor move() {
+		assert wrapped != null;
+		StateFunctor result = wrapped;
+		wrapped = null;
+		return result;
+	}
+
+	protected abstract void callImpl();
+
+	@Override
+	public final void call() {
+		try {
+			callImpl();
+		} catch (FramsticksException e) {
+			handle(e);
+			return;
+		}
+		if (wrapped != null) {
+			wrapped.call();
+		}
+	}
+
+	@Override
+	public void handle(FramsticksException exception) {
+		if (wrapped != null) {
+			wrapped.handle(exception);
+			return;
+		}
+		throw exception;
+	}
+
 	@Override
 	public void process(Response response) {
-		call(response.getOk() ? null : new Exception(response.getComment()));
+		if (response.getOk()) {
+			call();
+		} else {
+			handle(new FramsticksException().msg("non-ok response").arg("comment", response.getComment()));
+		}
 	}
 }
Index: /java/main/src/main/java/com/framsticks/communication/Subscription.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/Subscription.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/communication/Subscription.java	(revision 96)
@@ -7,4 +7,5 @@
 import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.RunAt;
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.StateFunctor;
 import org.apache.log4j.Logger;
@@ -52,10 +53,10 @@
 				if (!response.getOk()) {
 					log.error("failed to unsunscribe " + this + ": " + response.getComment());
-					stateFunctor.call(new Exception(response.getComment()));
+					stateFunctor.handle(new FramsticksException().msg("unsubscription failed").arg("comment", response.getComment()));
 					return;
 				}
 				assert response.hasFiles();
 				log.debug("unsunscribed " + this);
-				stateFunctor.call(null);
+				stateFunctor.call();
 			}
 		});
Index: /java/main/src/main/java/com/framsticks/communication/queries/ApplicationRequest.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/queries/ApplicationRequest.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/communication/queries/ApplicationRequest.java	(revision 96)
@@ -2,7 +2,7 @@
 
 import com.framsticks.communication.Request;
-import com.framsticks.util.lang.Delimeted;
+import com.framsticks.util.lang.Pair;
+import com.framsticks.util.lang.Strings;
 
-import java.util.Collection;
 
 /**
@@ -12,25 +12,10 @@
 
 	protected String path;
-	protected String fields;
 
 	public ApplicationRequest path(String path) {
-		assert path != null;
+		Strings.assureNotEmpty(path);
 		this.path = path;
 		return this;
 	}
-
-	public ApplicationRequest field(String field) {
-		this.fields = field;
-		return this;
-	}
-
-	public ApplicationRequest fields(Collection<String> fields) {
-		Delimeted d = new Delimeted(",", "");
-		for (String f : fields) {
-			d.append(f);
-		}
-		return field(d.build());
-	}
-
 
 	public String getPath() {
@@ -38,16 +23,15 @@
 	}
 
+
 	@Override
 	protected StringBuilder construct(StringBuilder buffer) {
-		buffer.append(' ').append(path);
-		if (fields != null) {
-			buffer.append(' ').append(fields);
-		}
-		return buffer;
+		return buffer.append(path);
 	}
 
 	@Override
-	public void parseRest(String rest) {
-		path = rest;
+	public CharSequence parseRest(CharSequence rest) {
+		final Pair<CharSequence, CharSequence> p = takeIdentifier(rest);
+		path = p.first.toString();
+		return p.second;
 	}
 
